unit WinMineControleur;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, shellapi, WinMineModele;

type
  TMarkStyle = (msMineMark, msQuestionMark, msNone);

  PCell = ^TCell;
  TCell = packed record
    cx: word;
    cy: word;
    case IsClosed: Boolean of
      True: (cMarked: TMarkStyle);
      False: (ciNumberAdjacentMine: byte);
  end;

  TMineField = array of array of TCell;
  TCFrame = array[0..7] of PCell;                           {Tableau de pointeurs de cellules}

  TListCellClose = array of Pcell;                          {Tableau de cellules pleines}

var
  MineField: TMineField;
  wmcwidth, wmcheight:byte;                                 {largeur, hauteur du champ de mines}
  LCC: TListCellClose;
  procedure GetCFrame(var cell:TCell; out Frame: TCFrame);
  function GetListCellClose(var MineField: TMineField;MFHeight: word; MFWidth: word;out LCC:TListCellClose): boolean;
  function DoSumFrame(const Frame :TCFrame):word;                 {retourne la somme des cases ouvertes du cadre de la cellule}

implementation

uses
  unit1;

  {------------------------------------------------------------------------------------------}
  {  X reprsente une cellule encadre par 8 cellules numrotes de 0  7.                   }
  {  Ces 8 cellules reprsentent le cadre de la cellule X.                                   }
  {  Si les cellules du cadre sont hors du champ de mine(par exemple si X est dans un coin)  }
  {  le pointeur de cellule est NIL sinon il pointe sur une cellule du champs de mine.       }
  {                                                                                          }
  {              0 3 5                                                                       }
  {              1 X 6                                                                       }
  {              2 4 7                                                                       }
  {  La fonction initialise le cadre.                                                        }
  {------------------------------------------------------------------------------------------}
  procedure GetCFrame(var cell:TCell;out Frame: TCFrame);
  var
    i:integer;
  begin
    {4 coins}
    if ((cell.cx  =0) and (cell.cy =0)) then
    begin
    frame[0] := nil;
    frame[1] := nil;
    frame[2] := nil;
    frame[3] := nil;
    frame[4] := @MineField[cell.cx, cell.cy +1];
    frame[5] := nil;
    frame[6] := @MineField[cell.cx+1, cell.cy];
    frame[7] := @MineField[cell.cx+1, cell.cy+1];
    end
    else
    if ((cell.cx = wmcwidth-1) and (cell.cy =0)) then
    begin
    frame[0] := nil;
    frame[1] := @MineField[cell.cx-1, cell.cy];
    frame[2] := @MineField[cell.cx-1, cell.cy+1];
    frame[3] := nil;
    frame[4] := @MineField[cell.cx, cell.cy +1];
    frame[5] := nil;
    frame[6] := nil;
    frame[7] := nil;
    end
    else
    if ((cell.cx = wmcwidth -1) and (cell.cy = wmcheight -1)) then
    begin
    frame[0] := @MineField[cell.cx-1, cell.cy-1];
    frame[1] := @MineField[cell.cx-1, cell.cy];
    frame[2] := nil;
    frame[3] := @MineField[cell.cx, cell.cy -1];
    frame[4] := nil;
    frame[5] := nil;
    frame[6] := nil;
    frame[7] := nil;
    end
    else
    if ((cell.cx  =0) and (cell.cy = wmcheight -1)) then
    begin
    frame[0] := nil;
    frame[1] := nil;
    frame[2] := nil;
    frame[3] := @MineField[cell.cx, cell.cy -1];
    frame[4] := nil;
    frame[5] := @MineField[cell.cx+1, cell.cy-1];
    frame[6] := @MineField[cell.cx+1, cell.cy];
    frame[7] := nil;
    end
    else
    {les autres bords}
    if ((cell.cx  =0) and  not (cell.cy =0) and not (cell.cy = wmcheight -1)) then
    begin
    frame[0] := nil;
    frame[1] := nil;
    frame[2] := nil;
    frame[3] := @MineField[cell.cx, cell.cy -1];
    frame[4] := @MineField[cell.cx, cell.cy +1];
    frame[5] := @MineField[cell.cx+1, cell.cy-1];
    frame[6] := @MineField[cell.cx+1, cell.cy];
    frame[7] := @MineField[cell.cx+1, cell.cy+1];
    end
    else
    if ((cell.cx = wmcwidth-1) and  not (cell.cy =0) and not (cell.cy = wmcheight -1)) then
    begin
    frame[0] := @MineField[cell.cx-1, cell.cy-1];
    frame[1] := @MineField[cell.cx-1, cell.cy];
    frame[2] := @MineField[cell.cx-1, cell.cy+1];
    frame[3] := @MineField[cell.cx, cell.cy -1];
    frame[4] := @MineField[cell.cx, cell.cy +1];
    frame[5] := nil;
    frame[6] := nil;
    frame[7] := nil;
    end
    else
    if ((cell.cy =0) and not  (cell.cx  =0) and not  (cell.cx = wmcwidth-1)) then
    begin
    frame[0] := nil;
    frame[1] := @MineField[cell.cx-1, cell.cy];
    frame[2] := @MineField[cell.cx-1, cell.cy+1];
    frame[3] := nil;
    frame[4] := @MineField[cell.cx, cell.cy +1];
    frame[5] := nil;
    frame[6] := @MineField[cell.cx+1, cell.cy];
    frame[7] := @MineField[cell.cx+1, cell.cy+1];
    end
    else
    if ((cell.cy = wmcheight -1) and not (cell.cx  =0) and not (cell.cx = wmcwidth-1)) then
    begin
    frame[0] := @MineField[cell.cx-1, cell.cy-1];
    frame[1] := @MineField[cell.cx-1, cell.cy];
    frame[2] := nil;
    frame[3] := @MineField[cell.cx, cell.cy -1];
    frame[4] := nil;
    frame[5] := @MineField[cell.cx+1, cell.cy-1];
    frame[6] := @MineField[cell.cx+1, cell.cy];
    frame[7] := nil;
    end
    else
    {ni sur une bordure ni dans un coin}
    begin
    frame[0] := @MineField[cell.cx-1, cell.cy-1];
    frame[1] := @MineField[cell.cx-1, cell.cy];
    frame[2] := @MineField[cell.cx-1, cell.cy+1];
    frame[3] := @MineField[cell.cx, cell.cy -1];
    frame[4] := @MineField[cell.cx, cell.cy +1];
    frame[5] := @MineField[cell.cx+1, cell.cy-1];
    frame[6] := @MineField[cell.cx+1, cell.cy];
    frame[7] := @MineField[cell.cx+1, cell.cy+1];
    end;
end;

function GetListCellClose(var MineField: TMineField;MFHeight: word; MFWidth: word;out LCC:TListCellClose):boolean;
var
  i, j: word;
  nbCellClose: word;
begin
  nbCellClose := 0;
  for i := 0 to MFWidth -1 do
    for j :=0 to MFHeight -1 do
    begin
      with MineField[i,j] do
      begin
        IsClosed := IsCellOpen(i,j);
        if (IsClosed  and (MineField[i,j].cMarked = msNone)) then
          begin
            Inc(nbCellClose);
            SetLength(LCC, nbCellClose);
            LCC[nbCellClose -1] := @MineField[i,j];
          end;
      end;
    end;
    result := True;
end;

function DoSumFrame(const Frame :TCFrame):word;
var
  i: byte;
  sum: Smallint;
  num: byte;
  countFlag:byte;
begin
  sum := 0;
  num := 0;
  countFlag := 0;
  result := 0;
  for i := 0 to 7 do
  begin
    if (frame[i]<>nil ) then
    begin
      if  not (frame[i]^.IsClosed)  then
      begin
        Frame[i]^.ciNumberAdjacentMine := GetNumOfMines(Frame[i]^.cx, Frame[i]^.cy);
        num := Frame[i]^.ciNumberAdjacentMine;
        if num = 99 then num := 0;
      end
      else
       num := 0;
      if ((frame[i]^.IsClosed) and (Frame[i].cMarked = msMineMark)) then
        countFlag := CountFlag + 1;
    sum := sum + num - countFlag;
    end;
  end;
  if sum < 0 then sum := 0;
  result := sum;
end;

end.


