unit WinMineModele;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, shellapi, Menus, syncobjs, ComCtrls, ExtCtrls;

type
  TCColor = array[1..2] of TCOLORREF;
  TVirtKeys = array of integer;
  TLevelStyle = (lsDebutant, lsIntermediaire, lsExpert, lsPersonnalise );
  TScoreRow = record
    Level: string;
    TimeElapsed: string;
    Winner: string;
  end;
  TScoresTab = array[1..3] of TScoreRow;

function GetScore(const h:HWND):boolean;
function GetFieldScreenOrigine(const h:hwnd):TPoint;
function IsColorChecked(const h:HWND):boolean;
function CleanScore(const h:HWND):Boolean;
function SendClick_v1(const h:HWND;x, y:integer):boolean;
function SendClick_v2(x, y:integer):boolean;
procedure SendText(const Wh:HWND; Text: string);
procedure SendText_v2(const Wh:HWND; var VK_CODES:TVirtKeys);
function SelectMenuItem(const hwinmine:HWND;Pos:byte):boolean;
function SetMenuItemPersonnalise():boolean;
function SendRightClick1(const h:HWND; x, y:integer):boolean;
function SendDoubleRightClick1(const h:HWND; x, y:integer):boolean;
procedure ReadScore(const h:HWND;out scores:TScoresTab);
Function  IsCellOpen(x, y:word):boolean;
function GetNumOfMines(x, y: byte):byte;
function GetMark(x,y:byte):byte;
procedure GetSizeOfFieldMine(out height: string; out width: string);
function GetNumOfAllMines():word;
{XP}
function ClickMenuItemXP(const hw: HWND; index:byte):boolean;
Function  IsCellOpenXP(x, y:word; dx, dy:word):boolean;  

implementation

uses unit1;

{ Rcupere les coordonnees cran de l'origine du champ de mine }
function GetFieldScreenOrigine(const h:hwnd):TPoint;
var
  rec: TRect;
  pp: TPoint;
begin
  Windows.GetClientRect(h, rec);
  pp.x := rec.left ;
  pp.y := rec.top ;
  Windows.ClientToScreen(h, pp);
  pp.x := pp.x + 12;
  pp.y := pp.y + 55;
  result := pp;
end;

{vrifie mode "couleur" slectionn}
function IsColorChecked(const h:HWND):boolean;
var
  p, pp   :TPoint;
  AColors :TCColor;
  Dc      :HDC;
begin
  GetCursorPos(P);
  pp := GetFieldScreenOrigine(h);
  SetCursorPos(pp.x, pp.y);
  DC := GetDC(0);
  AColors[1] := GetPixel(Dc, pp.x+8, pp.y+8);
  AColors[2] := GetPixel(Dc, pp.x+9, pp.y+8);
  if AColors[1] <> AColors[2] then
    result := False
  else
    result := True;
  ReleaseDc(0, Dc);
  SetCursorPos(P.X, P.Y);
end;

{function IsMarkChecked(h:HWND):boolean;
begin
end;}

function GetScore(const h:HWND):boolean;
begin
  result := false;
  if SelectMenuItem(h, 9) then result := True;
end;

function CleanScore(const h:HWND):Boolean;
var
  HFg:HWND;
  btnOK, btnEffacer: HWND;
  rec: TRect;
  p: TPoint;
  pp: TPoint;
  b: boolean;
begin
  result := false;
  GetScore(h);
  GetCursorPos(p);
  HFg := GetForegroundWindow();
  windows.SetFocus(HFg);

  btnOK := FindWindowEx(HFg,0,nil,nil);
  btnEffacer := FindWindowEx(HFg,btnOK,nil,nil);

  SetForegroundWindow(btnEffacer);
  b := Windows.GetClientRect(btnEffacer, rec);
  if b=false then
    raise Exception.Create('erreur click button Effacer');
  pp.x := rec.left;
  pp.y := rec.top;
  Windows.ClientToScreen(btnEffacer, pp);

  SendClick_v1(btnEffacer, pp.x+10, pp.y+10);

  b := Windows.GetClientRect(btnOK, rec);
  if b=false then
    raise Exception.Create('erreur click button OK');
  pp.x := rec.left;
  pp.y := rec.top;
  Windows.ClientToScreen(btnOK, pp);

  SendClick_v1(btnOK, pp.x+10, pp.y+10);
  SetCursorPos(p.x, p.y);
  result := True;
end;

{Simule un click gauche de la souris}
function SendClick_v1(const h:HWND; x, y:integer):boolean;
var
  pIn1,pIn2: TInput;
  mi1, mi2: TMouseInput;
  ClipCurs: TRect;
begin
  result := false;
  SetForegroundWindow(h);
  Windows.SetFocus(h);
  SetCursorPos(x,y);
  ClipCurs.TopLeft := Point(x,y);
  ClipCurs.BottomRight := Point(x+2,y+2);
  ClipCursor(@ClipCurs);
  with mi1 do
  begin
    dx :=0;
    dy := 0;
    mouseData := 0;
    dwFlags := MOUSEEVENTF_LEFTDOWN;
    time := 0;
    dwExtraInfo := 0;
  end;
  pIn1.mi := mi1;
  pIn1.IType:= INPUT_MOUSE;

  with mi2 do
  begin
    dx :=0;
    dy := 0;
    mouseData := 0;
    dwFlags := MOUSEEVENTF_LEFTUP;
    time := 0;
    dwExtraInfo := 0;
  end;
  pIn2.mi := mi2;
  pIn2.IType:= INPUT_MOUSE;
  ClipCursor(nil);   // Liberer le curseur avant l'appel  SendInput
  SendInput(2, pIn1, sizeof(pIn1));   
  SendInput(2, pIn2, sizeof(pIn2));
  result := True;
end;

{Simule un click gauche de la souris}
function SendClick_v2(x, y:integer):boolean;
var
  ClipCurs :TRect;
begin
  result := False;
  ClipCurs.TopLeft := Point(x-2,y-2);
  ClipCurs.BottomRight := Point(x+2,y+2);
  ClipCursor(@ClipCurs);
  SetCursorPos(x, y);

  Mouse_Event(MOUSEEVENTF_LEFTDOWN, x, y, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, x, y, 0, 0);
  ClipCursor(nil);
  result := True;
end;

{Envoie un texte  un control fenetr}
procedure SendText(const Wh:HWND; Text: string);
var
  TextMess :string;
  Len      :integer;
begin
  TextMess := text+#0;
  Len:=SendMessage(Wh,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(TextMess,Len);
  SendMessage(Wh,WM_SETTEXT,0,LPARAM(TextMess));
end;

{Envoie un texte  un control fenetr}
procedure SendText_v2(const Wh:HWND; var VK_CODES:TVirtKeys);
Var
  Len :integer;
  i   :integer;
begin
  Len:=SendMessage(Wh,WM_GETTEXTLENGTH,0,0);
   While Len >0 do
   begin
   PostMessage(Wh, WM_KEYDOWN,VK_DELETE, 0);
   Dec(Len);
   end;
    for i := Low(VK_CODES) to High(VK_CODES) do
     PostMessage(Wh, WM_KEYDOWN,VK_CODES[i], 0);
end;

{Simule un click sur un item du menuitem 'Partie'
 pos: 1  10}
function SelectMenuItem(const hwinmine:HWND;Pos:byte):boolean;
var
  rec      :TRect;
  p, pp    :TPoint;
  i        :integer;
  ClipCurs :TRect;
begin
  result := false;
  Windows.GetClientRect(HWinmine, rec);
   pp.x := rec.left+5;
   pp.y := rec.top-10;
  Windows.ClientToScreen(HWinmine, pp);
  GetCursorPos(P);
  SetCursorPos( pp.x , pp.y );
  SendClick_v1(hwinmine,pp.x, pp.y);
  ClipCurs.TopLeft := Point(pp.x+100,pp.y);
  ClipCurs.BottomRight := Point(pp.x+100,pp.y);
  ClipCursor(@ClipCurs);
  for i := 0 to pos-1 do
  begin
   keybd_event(VK_DOWN, 0, 0, 0);
  end;
  keybd_event(VK_RETURN, 0, 0, 0);
  ClipCursor(nil);
  SetCursorPos(p.x, p.y);
  result := true;
end;

{Initialise width, height, nombre de mines}
function SetMenuItemPersonnalise():boolean;
var
  IWidth   :word;
  IHeight  :word;
  rec      :TRect;
  p        :TPoint;
  pp       :TPoint;
  HFg,edt,edt2,edt3,btn,btn2,lb1,lb2,lb3: hwnd;
  text     :string;
  b        :boolean;
  ClipCurs :TRect;
begin
  Windows.GetClientRect(HWinMine, rec);
  pp.x := rec.left+5;
  pp.y := rec.top-10;
  Windows.ClientToScreen(HWinMine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);
  { Clique sur le menu "Partie" }
  SetCursorPos( pp.x , pp.y );

  ClipCursor(nil);
  SendClick_v1(HWinMine, pp.x, pp.y);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);

  ClipCursor(nil);
  {Clique sur le sous-menu "Personnalis"}
  SendClick_v2(pp.x, pp.y+100);

  ClipCurs.TopLeft := Point(pp.x-5,pp.y+99);
  ClipCurs.BottomRight := Point(pp.x+10,pp.y+101);
  ClipCursor(@ClipCurs);
  { La fentre champs personnaliss est affiche, place le focus clavier dessus }
  HFg := GetForegroundWindow();
  windows.SetFocus(HFg);

  { Liste toute la hierarchie de composants de la fiche }
  btn  := FindWindowEx(HFg,0,nil,nil);
  btn2 := FindWindowEx(HFg,btn,nil,nil);
  lb1  := FindWindowEx(HFg,btn2,nil,nil);
  edt  := FindWindowEx(HFg,lb1,nil,nil);
  lb2  := FindWindowEx(HFg,edt,nil,nil);
  edt2 := FindWindowEx(HFg,lb2,nil,nil);
  lb3  := FindWindowEx(HFg,edt2,nil,nil);
  edt3 := FindWindowEx(HFg,lb3,nil,nil);

  {-------------------------------------------}
  {  Prvoir un Random Randomize              }
  {-------------------------------------------}

  { la hauteur }
  { SetLength(textedt,2);
   textedt[0] := VK_NUMPAD1;
   textedt[1] := VK_NUMPAD9;
   SendText_v2(edt,textedt);  }
   IWidth := random(100)+10;
   text := IntToStr(IWidth);
   SendText(Edt, text);

  { la largeur}
  IHeight := random(100)+10;
  text := IntToStr(IHeight);
  SendText(Edt2, text);

  { le nombre de mines }
  text :=IntToStr(random((IHeight div 2)*(IWidth div 2)));
  SendText(Edt3, text);

  { Place le curseur sur le button OK et clique }
  SetForegroundWindow(btn);
  b := Windows.GetClientRect(btn, rec);
  if b=false then
    raise Exception.Create('erreur click button OK');
  pp.x := rec.left;
  pp.y := rec.top;
  Windows.ClientToScreen(btn, pp);

  ClipCursor(nil);
  SendClick_v1(btn, pp.x+10, pp.y+10);
  SetCursorPos(P.X, P.Y);  //inutile reinitialise la position curseur
end;

procedure ReadScore(const h:HWND;out scores:TScoresTab);
var
  hFg:HWND;
  btnOK, btnEffacer: HWND;
  lbl1, lbl2, lbl3, lbl4, lbl5: HWND;
  lbl6, lbl7, lbl8, lbl9: HWND;
  rec  :TRect;
  p    :TPoint;
  pp   :TPoint;
  text :string;
  b    :boolean;
  Len  :integer;
begin
  GetScore(h);
  GetCursorPos(p);
  hFg := GetForegroundWindow();
  windows.SetFocus(hfg);

  btnOK := FindWindowEx(hfg,0,nil,nil);
  btnEffacer := FindWindowEx(hfg,btnOK,nil,nil);
  lbl1 := FindWindowEx(hfg,btnEffacer,nil,nil);
  lbl2 := FindWindowEx(hfg,lbl1,nil,nil);
  lbl3 := FindWindowEx(hfg,lbl2,nil,nil);

  Len:=SendMessage(lbl2,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(lbl2,WM_GETTEXT,Len,Integer(@Text[1]));
  scores[1].TimeElapsed := text;

  Len:=SendMessage(lbl3,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(lbl3,WM_GETTEXT,Len,Integer(@Text[1]));
  scores[1].Winner := text;

  lbl4 := FindWindowEx(HFg,lbl3,nil,nil);
  lbl5 := FindWindowEx(HFg,lbl4,nil,nil);
  lbl6 := FindWindowEx(HFg,lbl5,nil,nil);

  Len:=SendMessage(lbl5,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(lbl5,WM_GETTEXT,Len,Integer(@Text[1]));
  scores[2].TimeElapsed := text;

  Len:=SendMessage(lbl6,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(lbl6,WM_GETTEXT,Len,Integer(@Text[1]));
  scores[2].Winner := text;

  lbl7 := FindWindowEx(HFg,lbl6,nil,nil);
  lbl8 := FindWindowEx(HFg,lbl7,nil,nil);
  lbl9 := FindWindowEx(HFg,lbl8,nil,nil);

  Len:=SendMessage(lbl8,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(lbl8,WM_GETTEXT,Len,Integer(@Text[1]));
  scores[3].TimeElapsed := text;

  Len:=SendMessage(lbl9,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(lbl9,WM_GETTEXT,Len,Integer(@Text[1]));
  scores[3].Winner := text;

  btnOK := FindWindowEx(HFg,0,nil,nil);
  b := Windows.GetClientRect(btnOK, rec);
  if b=false then
    raise Exception.Create('erreur click button OK');
  pp.x := rec.left;
  pp.y := rec.top;
  Windows.ClientToScreen(btnOK, pp);

  SendClick_v1(btnOK, pp.x+10, pp.y+10);
  SetCursorPos(p.x, p.y);
end;

function SendRightClick1(const h:HWND; x, y:integer):boolean;
var
  pIn1,pIn2  :TInput;
  mi1, mi2   :TMouseInput;
  ClipCurs   :TRect;
begin
  SetForegroundWindow(h);
  SetCursorPos(x,y);
  ClipCurs.TopLeft := Point(x,y);
  ClipCurs.BottomRight := Point(x+2,y+2);
  ClipCursor(@ClipCurs);
  with mi1 do
  begin
    dx :=0;
    dy := 0;
    mouseData := 0;
    dwFlags := MOUSEEVENTF_RIGHTDOWN;
    time := 0;
    dwExtraInfo := 0;
  end;
  pIn1.mi := mi1;
  pIn1.IType:= INPUT_MOUSE;

  with mi2 do
  begin
    dx :=0;
    dy := 0;
    mouseData := 0;
    dwFlags := MOUSEEVENTF_RIGHTUP;
    time := 0;
    dwExtraInfo := 0;
  end;
  pIn2.mi := mi2;
  pIn2.IType:= INPUT_MOUSE;
  ClipCursor(nil);   // Imprativement liberer le curseur avant l'appel  SendInput!
  SendInput(2, pIn1, sizeof(pIn1));
  SendInput(2, pIn2, sizeof(pIn2));
end;

function SendDoubleRightClick1(const h:HWND; x, y:integer):boolean;
var
  pIn1,pIn2  :TInput;
  mi1, mi2   :TMouseInput;
  ClipCurs   :TRect;
begin
  SetForegroundWindow(h);
  SetCursorPos(x,y);
  ClipCurs.TopLeft := Point(x,y);
  ClipCurs.BottomRight := Point(x+2,y+2);
  ClipCursor(@ClipCurs);
  with mi1 do
  begin
    dx :=0;
    dy := 0;
    mouseData := 0;
    dwFlags := MOUSEEVENTF_RIGHTDOWN;
    time := 0;
    dwExtraInfo := 0;
  end;
  pIn1.mi := mi1;
  pIn1.IType:= INPUT_MOUSE;

  with mi2 do
  begin
    dx :=0;
    dy := 0;
    mouseData := 0;
    dwFlags := MOUSEEVENTF_RIGHTUP;
    time := 0;
    dwExtraInfo := 0;
  end;
  pIn2.mi := mi2;
  pIn2.IType:= INPUT_MOUSE;
  ClipCursor(nil);   // Imprativement liberer le curseur avant l'appel  SendInput!
  SendInput(2, pIn1, sizeof(pIn1));
  SendInput(2, pIn2, sizeof(pIn2));
  SendInput(2, pIn1, sizeof(pIn1));
  SendInput(2, pIn2, sizeof(pIn2));
end;

{ Teste si la case est ferme. Souris dans le coin Haut Gauche de la case }
Function  IsCellOpen(x, y:word):boolean;      //ligne blanche
var
  p, pp      :TPoint;
  CColor     :TCOLORREF;
  Dc         :HDC;
  ColorWhite :TColor;
begin
  result := false;
  GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  ColorWhite := $00FFFFFF;
  DC := GetDC(0);
  CColor := GetPixel(Dc,pp.x+1+16*x,pp.y+1+16*y);
  SetCursorPos(pp.x+1+16*x, pp.y+1+16*y);
  if  ColorWhite = TColor(CColor) then
  result := True;
  ReleaseDc(0, Dc);
  SetCursorPos(p.x, p.y);
end;

{ Si la cellule est ouverte on rcupre le nombre de mines 0..8 }
function GetNumOfMines(x, y: byte):byte; { Centre la souris sur la case }
var
  p, pp   :TPoint;
  CColor  :TCOLORREF;
  Dc      :HDC;

begin
  GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  DC := GetDC(0);
  CColor := GetPixel(Dc,pp.x+8+16*x,pp.y+8+16*y);
  SetCursorPos(pp.x+8+16*x, pp.y+8+16*y);
  case TColor(CColor) of
  $00C6C3C6: result := 0;   //couleur de fond gris
  $00FF0000: result := 1;   //bleu
  $00008200: result := 2;   //vert
  $000000FF: result := 3;   //rouge
  $00840000: result := 4;
  $00000084: result := 5;
  $00848200: result := 6;
  $00000000: result := 99; //noir
  else
    result := 255;      // couleur inconnue, penser  la rcuperer
  end;
  ReleaseDc(0, Dc);
  SetCursorPos(p.x, p.y);
end;

function GetMark(x,y:byte):byte;
var
  p, pp   :TPoint;
  CColor  :TCOLORREF;
  Dc      :HDC;

begin
  GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  SetCursorPos(pp.x+8+16*x, pp.y+8+16*y);
  DC := GetDC(0);
  if not  IsCellOpen(pp.x+8+16*x,pp.y+8+16*y) then
  begin
    CColor := GetPixel(Dc,pp.x+6+16*x,pp.y+4+16*y);
    case TColor(CColor) of
      $00C6C3C6: result := 0;  //pas de marques
      $000000FF: result := 1;  //drapeau
      $00000000: result := 2;  //point d'interrogation
  else
    result := 255;
  end;
  end;
  ReleaseDc(0, Dc);
  SetCursorPos(p.x, p.y);
end;

procedure GetSizeOfFieldMine(out height: string; out width: string);
var
  rec      :TRect;
  p        :TPoint;
  pp       :TPoint;
  HFg,edt,edt2,edt3,btn,btn2,lb1,lb2,lb3: hwnd;
  Len      :integer;
  b        :boolean;
  ClipCurs :TRect;

begin

  Windows.GetClientRect(HWinmine, rec);
   pp.x := rec.left+5;
   pp.y := rec.top-10;
  Windows.ClientToScreen(HWinmine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);
  { Clique sur le menu "Partie" }
  SetCursorPos( pp.x , pp.y );

  ClipCursor(nil);
  SendClick_v1(hwinmine, pp.x, pp.y);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);

  ClipCursor(nil);
  {Clique sur le sous-menu "Personnalis"}
  SendClick_v2(pp.x, pp.y+100);

  ClipCurs.TopLeft := Point(pp.x-5,pp.y+99);
  ClipCurs.BottomRight := Point(pp.x+10,pp.y+101);
  ClipCursor(@ClipCurs);
  { La fentre champs personnaliss est affiche, place le focus dessus }
  HFg := GetForegroundWindow();
  windows.SetFocus(HFg);

  { Liste toute la hierarchie de composants de la fiche }
  btn  := FindWindowEx(HFg,0,nil,nil);
  btn2 := FindWindowEx(HFg,btn,nil,nil);
  lb1  := FindWindowEx(HFg,btn2,nil,nil);
  edt  := FindWindowEx(HFg,lb1,nil,nil);
  lb2  := FindWindowEx(HFg,edt,nil,nil);
  edt2 := FindWindowEx(HFg,lb2,nil,nil);
  lb3  := FindWindowEx(HFg,edt2,nil,nil);
  edt3 := FindWindowEx(HFg,lb3,nil,nil);

  Len:=SendMessage(edt2,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Width,Len);
  SendMessage(edt2,WM_GETTEXT,Len,Integer(@Width[1]));
  Len:=SendMessage(edt,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Height,Len);
  SendMessage(edt,WM_GETTEXT,Len,Integer(@Height[1]));
  SetForegroundWindow(btn);
  b := Windows.GetClientRect(btn, rec);
  if b=false then
    raise Exception.Create('Erreur GetSizeOfFieldMineClick()-Echec GetClientRect(btn,...)');
  pp.x := rec.left;
  pp.y := rec.top;
  Windows.ClientToScreen(btn, pp);

  ClipCursor(nil);
  SendClick_v1(btn, pp.x+10, pp.y+10);
  SetCursorPos(P.X, P.Y);
end;

{retourne le nbre de mines }
function GetNumOfAllMines():word;
var
  rec      :TRect;
  p        :TPoint;
  pp       :TPoint;
  HFg,edt,edt2,edt3,btn,btn2,lb1,lb2,lb3: hwnd;
  Len      :integer;
  text     :string;
  b        :boolean;
  ClipCurs :TRect;
begin
  Windows.GetClientRect(HWinMine, rec);
   pp.x := rec.left+5;
   pp.y := rec.top-10;
  Windows.ClientToScreen(HWinMine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);
  { Clique sur le menu "Partie" }
  SetCursorPos( pp.x , pp.y );

  ClipCursor(nil);
  SendClick_v1(HWinMine, pp.x, pp.y);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);

  ClipCursor(nil);
  {Clique sur le sous-menu "Personnalis"}
  SendClick_v2(pp.x, pp.y+100);

  ClipCurs.TopLeft := Point(pp.x-5,pp.y+99);
  ClipCurs.BottomRight := Point(pp.x+10,pp.y+101);
  ClipCursor(@ClipCurs);
  { La fentre champs personnaliss est affiche, place le focus clavier dessus }
  HFg := GetForegroundWindow();
  windows.SetFocus(HFg);

  { Liste toute la hierarchie de composants de la fiche }
  btn  := FindWindowEx(HFg,0,nil,nil);
  btn2 := FindWindowEx(HFg,btn,nil,nil);
  lb1  := FindWindowEx(HFg,btn2,nil,nil);
  edt  := FindWindowEx(HFg,lb1,nil,nil);
  lb2  := FindWindowEx(HFg,edt,nil,nil);
  edt2 := FindWindowEx(HFg,lb2,nil,nil);
  lb3  := FindWindowEx(HFg,edt2,nil,nil);
  edt3 := FindWindowEx(HFg,lb3,nil,nil);

  Len:=SendMessage(Edt3,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Text,Len);
  SendMessage(Edt3,WM_GETTEXT,Len,Integer(@Text[1]));
  { Place le curseur sur le button OK et clique }
  SetForegroundWindow(btn);
  b := Windows.GetClientRect(btn, rec);
  if b=false then
    raise Exception.Create('erreur click button OK');
  pp.x := rec.left;
  pp.y := rec.top;
  Windows.ClientToScreen(btn, pp);

  ClipCursor(nil);
  SendClick_v1(btn, pp.x+10, pp.y+10);
  SetCursorPos(P.X, P.Y);
  result := StrToInt(text);
end;

{----------------------------------------------------------------------------}
{Compatibilit XP}
{----------------------------------------------------------------------------}

{parametre index: index de l'item =1 pour "Nouveau", =10 pour "Quitter" }
function ClickMenuItemXP(const hw: HWND; index:byte):boolean;
var
  rec: TRect;
  p: TPoint;
  pp: TPoint;
  hfor,edt,edt2,edt3,btn,btn2,lb1,lb2,lb3: hwnd;
  Len: integer;
  text:string;
  btnOK: hwnd;
  LParam1: LPARAM;
  dwWParam: LPARAM;
  b:boolean;
  i:integer;
  textedt: TVirtKeys;
  ClipCurs: TRect;
begin
  if not index in [0..9] then
  begin
    result := False;exit;
    SendClick_v2(pp.x, pp.y+ index);
  end;

  Windows.GetClientRect(hw, rec);
  pp.x := rec.left+5;
  pp.y := rec.top-10;
  Windows.ClientToScreen(HWinmine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);
  { Clique sur le menu "Partie" }
  SetCursorPos( pp.x , pp.y);

  ClipCursor(nil);
  sleep(500);
  SendClick_v1(hwinmine, pp.x, pp.y);
  ClipCurs.TopLeft := Point(pp.x-5,pp.y+99);
  ClipCurs.BottomRight := Point(pp.x+10,pp.y+101);
  ClipCursor(@ClipCurs);
  SendClick_v2(pp.x, pp.y+index*20);
  SetCursorPos(P.X, P.Y);
end;

Function  IsCellOpenXP(x, y:word; dx, dy:word):boolean;      //ligne blanche
var
  p, pp      :TPoint;
  CColor     :TCOLORREF;
  Dc         :HDC;
  ColorWhite :TColor;
begin
  result := false;
  GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  ColorWhite := $00FFFFFF;
  DC := GetDC(0);
  CColor := GetPixel(Dc,pp.x+1+dx+16*x,pp.y+1+dy+16*y);
  SetCursorPos(pp.x+1+dx+16*x,pp.y+1+dy+16*y);
  sleep(1000);
  if  ColorWhite = TColor(CColor) then
  result := True;
  ReleaseDc(0, Dc);
  SetCursorPos(p.x, p.y);
end;

end.


